import Adw from 'gi://Adw';
import Gio from 'gi://Gio';
import Gtk from 'gi://Gtk';
import { ExtensionPreferences, gettext as _, } from 'resource:///org/gnome/Shell/Extensions/js/extensions/prefs.js';
export default class WindowDesaturationPreferences extends ExtensionPreferences {
    _settings;
    async fillPreferencesWindow(window) {
        this._settings = this.getSettings();
        const page = new Adw.PreferencesPage({
            title: _('General'),
            iconName: 'dialog-information-symbolic',
        });
        window.add(page);
        const group = new Adw.PreferencesGroup({
            title: _('Desaturation'),
            description: _('Configure desaturation'),
        });
        page.add(group);
        const row = new Adw.ActionRow({
            title: _('Background'),
            subtitle: _('How much to desaturate background windows'),
        });
        group.add(row);
        const backgroundFactor = new Gtk.Scale({
            hexpand: true,
            orientation: Gtk.Orientation.HORIZONTAL,
            adjustment: new Gtk.Adjustment({
                lower: 0.0,
                upper: 1.0,
                step_increment: 0.05,
                page_increment: 0.25,
            }),
        });
        row.add_suffix(backgroundFactor);
        // FIXME: bind_with_mapping fails for some reason
        this._settings?.bind('desaturation-factor-background', backgroundFactor.adjustment, 'value', Gio.SettingsBindFlags.DEFAULT);
    }
}
